/* Events: Sample, Zero Crossings, Relations, Discrete Changes */
#include "RoomHeating_OM_RH_model.h"
#if defined(__cplusplus)
extern "C" {
#endif

/* Initializes the raw time events of the simulation using the now
   calcualted parameters. */
void RoomHeating_OM_RH_function_initSample(DATA *data, threadData_t *threadData)
{
  long i=0;
}

const char *RoomHeating_OM_RH_zeroCrossingDescription(int i, int **out_EquationIndexes)
{
  static const char *res[] = {"valveopen > 0.0",
  "fanspeed > 0.0"};
  static const int occurEqs0[] = {1,29};
  static const int occurEqs1[] = {1,22};
  static const int *occurEqs[] = {occurEqs0,occurEqs1};
  *out_EquationIndexes = (int*) occurEqs[i];
  return res[i];
}

/* forwarded equations */

int RoomHeating_OM_RH_function_ZeroCrossingsEquations(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH

  data->simulationInfo->callStatistics.functionZeroCrossingsEquations++;

  
  TRACE_POP
  return 0;
}

int RoomHeating_OM_RH_function_ZeroCrossings(DATA *data, threadData_t *threadData, double *gout)
{
  TRACE_PUSH
  const int *equationIndexes = NULL;

  modelica_boolean tmp0;
  modelica_real tmp1;
  modelica_real tmp2;
  modelica_boolean tmp3;
  modelica_real tmp4;
  modelica_real tmp5;

#if !defined(OMC_MINIMAL_RUNTIME)
  if (measure_time_flag) rt_tick(SIM_TIMER_ZC);
#endif
  data->simulationInfo->callStatistics.functionZeroCrossings++;

  tmp1 = 1.0;
  tmp2 = 0.0;
  tmp0 = GreaterZC((data->localData[0]->realVars[20] /* valveopen variable */), 0.0, tmp1, tmp2, data->simulationInfo->storedRelations[0]);
  gout[0] = (tmp0) ? 1 : -1;

  tmp4 = 1.0;
  tmp5 = 0.0;
  tmp3 = GreaterZC((data->localData[0]->realVars[10] /* fanspeed variable */), 0.0, tmp4, tmp5, data->simulationInfo->storedRelations[1]);
  gout[1] = (tmp3) ? 1 : -1;

#if !defined(OMC_MINIMAL_RUNTIME)
  if (measure_time_flag) rt_accumulate(SIM_TIMER_ZC);
#endif

  TRACE_POP
  return 0;
}

const char *RoomHeating_OM_RH_relationDescription(int i)
{
  const char *res[] = {"valveopen > 0.0",
  "fanspeed > 0.0"};
  return res[i];
}

int RoomHeating_OM_RH_function_updateRelations(DATA *data, threadData_t *threadData, int evalforZeroCross)
{
  TRACE_PUSH
  const int *equationIndexes = NULL;

  modelica_boolean tmp6;
  modelica_real tmp7;
  modelica_real tmp8;
  modelica_boolean tmp9;
  modelica_real tmp10;
  modelica_real tmp11;
  
  if(evalforZeroCross) {
    tmp7 = 1.0;
    tmp8 = 0.0;
    tmp6 = GreaterZC((data->localData[0]->realVars[20] /* valveopen variable */), 0.0, tmp7, tmp8, data->simulationInfo->storedRelations[0]);
    data->simulationInfo->relations[0] = tmp6;

    tmp10 = 1.0;
    tmp11 = 0.0;
    tmp9 = GreaterZC((data->localData[0]->realVars[10] /* fanspeed variable */), 0.0, tmp10, tmp11, data->simulationInfo->storedRelations[1]);
    data->simulationInfo->relations[1] = tmp9;
  } else {
    data->simulationInfo->relations[0] = ((data->localData[0]->realVars[20] /* valveopen variable */) > 0.0);

    data->simulationInfo->relations[1] = ((data->localData[0]->realVars[10] /* fanspeed variable */) > 0.0);
  }
  
  TRACE_POP
  return 0;
}

#if defined(__cplusplus)
}
#endif

